const http = require('http');
const sandbox = require('./sandbox.js')

console.log('starting worker: ' , process.pid );

var server = http.createServer(function(req, response ) {

    //send the process id for timeout function
    process.send(process.pid)

    var body = '';
    req.on('data', function (data) {
        body += data;
        // console.log("Partial body: " + body);
    });
    req.on('end', function () {
      // console.log("POST Body: ", body);
      var scriptObj = JSON.parse( body )
      sandbox( scriptObj.script , scriptObj.libs , scriptObj.context, function(err, res ){

        // console.log('sandbox res: ', res );

        //ask master to clear the master timeout
        process.send( "clearTimeout");

        response.writeHead(200, { 'Content-Type': 'application/json'});
        var output = res || err

        if (err ){
          // response.statusCode = 404
          response.writeHead(500, { 'Content-Type': 'application/json'});
          // output = { status: 500, message: err }
        }

        response.write( JSON.stringify( output ) ); // errors were not being reported

        response.end()

      });
    });
}).listen(8000);


server.on('listening', function(){
  // console.log('server listening ')
  process.send( 'ready' );
});
