//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

const Promise = require('bluebird')
const requestlib = require("request");
const intercept = require("intercept-stdout");
const vm = require('vm');


//-----------------------------------------------------------------------------
// Main
//-----------------------------------------------------------------------------
const hijackReturnStatement = function( code ){
  var acorn = require('acorn');
  // var walk = require("acorn/dist/walk");
  var walk = require( 'estree-walker' ).walk;
  var _ = require('lodash')

  timeA = Date.now()
  // var code = 'var test = function(){ var x = 42; var test = function(){ return nothing }; return whatever + x }; test()'
  // var code = 'var test = function(){ var x = 42; return whatever }; test()'

  var ast = acorn.parse(code);

  // console.log('ast', JSON.stringify(ast, null, 4) );
  // console.log('ast', JSON.stringify(ast.body[0].declarations[0], null, 4) );
  //
  // codeBodyNode = ast.body[0].declarations[0]
  // console.log('codeBodyNode', JSON.stringify(codeBodyNode , null, 4)  )
  //
  //   if( codeBodyNode.type == 'VariableDeclarator' && codeBodyNode.id.name == "test"  ){
  //     // console.log('codeBodyNode: ', codeBodyNode.init.body.body );
  //     var functionBody = codeBodyNode.init.body.body
  //     var returnDoc = _.filter( functionBody, function ( each ){
  //       return each.type === "ReturnStatement"
  //     })
  //   }
  //


  var returnInstances

  walk( ast, {
    enter: function ( node, parent ) {
      if( node.type == 'VariableDeclarator' && node.id.name == "test"  ){
        returnInstances = node.init.body.body
        this.skip()//stop recursive walk when this is found.
      }
    },
  });

  // console.log('mainFunction', JSON.stringify( returnInstances, null, 4 ) );

  var returnDoc = _.filter( returnInstances, function ( each ){
    return each.type === "ReturnStatement"
  })

  console.log('mainFunction', JSON.stringify( returnDoc, null, 4 ) );
  console.log('return argument', code.slice( returnDoc[0].argument.start, returnDoc[0].argument.end ) );
  var returnArg = code.slice( returnDoc[0].argument.start, returnDoc[0].argument.end )
  newCode = code.slice( 0 ,returnDoc[0].start ) + 'done('+ returnArg + ')' + code.slice( returnDoc[0].end )
  console.log('mainFunction', newCode );


  console.log('time:', Date.now() - timeA );
  return newCode
}

const sandbox = function(script, whiteListedLibraries, defaultContext, callback ){
  // contextify needs to be run new everytime.
  var Contextify = new require('contextify');

////////////// PREP ARGS FOR VM //////////////////////
  timeA =  Date.now()
  self = this
  timeoutValue = 5000 //millisecond timemout on all sandbox ops
  var sandboxOutput = {}
  var exitCode = 0
  var sandboxLogs = []
  var sandboxError

  if ( !defaultContext ) {
    var defaultContext = {}
  }
    //standard utils
  defaultContext.setTimeout = setTimeout
  defaultContext.console = console
  defaultContext.Buffer = Buffer
  defaultContext.JSON = JSON


  //// TODO: GROSS, this function should be defined in wireline, not in module
  defaultContext.httpRequest = function( requestObj ) {
    try{
      return new Promise(function (resolve, reject) {
          requestlib( requestObj , function (err, res, body) {
              if (err) {
                  return reject(err);
              }
              // } else if (res.statusCode !== 200) {
              //     err = new Error("Unexpected status code: " + res.statusCode);
              //     err.res = res;
              //     return reject(err);
              // }
              // console.log('res', res);
              resolve(body);
          });
      });
    }catch(e){
        // process.send({ status: 'ERROR', errorName: e.name, errorMessage: e.message } ) ; // pass exception object to error handler
        sandboxOutput = { status: 'ERROR', result: e.name +" : " +  e.message }
        exitCode = 1
      }
    }

    // whiteListedLibraries = []
    if ( whiteListedLibraries ) {
      // var defaultContext = { }
      for (var i = 0, len = whiteListedLibraries.length; i < len; i++) {
        // import each library with require as necessary.
        defaultContext[ whiteListedLibraries[i].namespace ]   =  require( whiteListedLibraries[i].npm );
      }
    }

    // timeA =  Date.now()
    Contextify = Contextify( defaultContext )
    // console.log('time Contextify setup : ', Date.now() - timeA );

    // console.log('sandbox2.js - script ', script );
  // script =  'wrapper=function(){ return 1+1 }'

  /// TODO: GROSS I don't like this. How can we tell between sync and asyc scripts

  // var script = hijackReturnStatement( script )
  // console.log('script to run:', script );

  if ( script.indexOf( 'done(') > 0 ){
    var wrappedCode = "(function(done) {" + script + "; })"

  }else{


    var wrappedCode = "(function(done) {" + script + "; done()})"
  }




  // var timeoutID = setTimeout(function(){
  //    console.log('timeout sandbox');
  //   //  process.exit(1);
  //    process.abort()
  // }, 1000 );


  try {
    console.log('sandbox.js -  running');
    //ASYNC
    timeA =  Date.now()

    //intercept logs
    //https://www.npmjs.com/package/intercept-stdout


    interceptedLogs = [];
    //this initializes the intercept and calling it will end the intercept
    var endIntercept = intercept(function(txt) {
        interceptedLogs.push(txt) //+= txt;
    });


    //// TODO: NODE 4.5.0 implementation
    // var newContext = vm.createContext( defaultContext )
    //
    // var sandbox2 = vm.runInContext( wrappedCode, newContext )(function(){
    //   // console.log('time Contextify run : ', Date.now() - timeA );
    //
    //    //the sandbox returns a string. Need to parse again
    //    var sandboxResult = newContext.RESULT
    //
    //    //message the parent sandbox.js with the result
    //
    //   //  TODO: should we handle an undefined?
    //   //  if ( sandboxResult === undefined ){
    //   //    exitCode = 1
    //   //    sandboxResult = 'undefined'
    //   //  }
    //
    //    sandboxOutput = { status: 'COMPLETE',result: sandboxResult }
    //
    //    exitCode = 0
    //    //kills the sandbox after the timeout
    //    Contextify.dispose();
    //
    //    //stop intercepting console logs
    //    endIntercept();
    //    sandboxOutput.console = interceptedLogs
    //
    //   //  console.log("This text is not being captured");
    //    console.log('captured_text',  interceptedLogs );
    //
    //
    //    if ( callback && exitCode === 0  ){
    //      callback(null, sandboxOutput)
    //    }
    //
    // })
    // console.log('newContext ', newContext.RES );

//////////////// NODE 0.10 implementation: /////////////////
    Contextify.run( wrappedCode )(function( callbackResult ) {
      // console.log('result in callback', callbackResult);
      // console.log('process outside', process.pid);


      // console.log('time Contextify run : ', Date.now() - timeA );

    var sandboxResult

     if( callbackResult ){
      sandboxResult = callbackResult
    }else{
      sandboxResult = Contextify.RESULT
    }
     //the sandbox returns a string. Need to parse again

     //message the parent sandbox.js with the result

    //  TODO: should we handle an undefined?
    //  if ( sandboxResult === undefined ){
    //    exitCode = 1
    //    sandboxResult = 'undefined'
    //  }

     sandboxOutput = { status: 'COMPLETE',result: sandboxResult }

     exitCode = 0
     //kills the sandbox after the timeout
     Contextify.dispose();

     //stop intercepting console logs
     endIntercept();
     sandboxOutput.console = interceptedLogs

    //  console.log("This text is not being captured");
     console.log('sandbox.js - captured_text',  interceptedLogs );


     if ( callback && exitCode === 0  ){
       callback(null, sandboxOutput)
     }

    //  exits with error or kill signal
     if ( callback && (exitCode != 0 ) ){
       callback( sandboxOutput , null)
     }

     console.log('sandbox2.js - Async Complete')
    });
    //////////////////////// END NODE 0.10 implementation ////////////////////////
  }
  catch (e) {
   // send message back to parent sandbox.js  with handled  exceptions from the sandbox
    //endIntercept may not have ended
    endIntercept()
    sandboxOutput = { status: 'ERROR', result: e.name +" : " +  e.message, console:  interceptedLogs}
    console.log('sandbox.js - error: ', sandboxOutput);
    exitCode = 1
    if ( callback && (exitCode != 0 ) ){
      callback( sandboxOutput , null)
    }
  }




}


//-----------------------------------------------------------------------------
// EXPORTS
//-----------------------------------------------------------------------------

module.exports = sandbox;
