//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

Contextify = require('contextify');

//-----------------------------------------------------------------------------
// Module
//-----------------------------------------------------------------------------

// Get arguments passed in from parent process
childProcessArgs = process.argv.slice(2);
// console.log( childProcessArgs );

code = childProcessArgs[0];

whiteListedLibraries = JSON.parse( childProcessArgs[1] );
defaultContext = JSON.parse( childProcessArgs[2] )

//standard utils
defaultContext.setTimeout = setTimeout
defaultContext.console = console
defaultContext.Buffer = Buffer
defaultContext.JSON = JSON



if ( whiteListedLibraries ) {
  // var defaultContext = { }
  for (var i = 0, len = whiteListedLibraries.length; i < len; i++) {
    // import each library with require as necessary.
    defaultContext[ whiteListedLibraries[i].namespace ]   =  require( whiteListedLibraries[i].npm );
  }
}

Contextify = Contextify( defaultContext )

try {
  //  throw "myException"; // generates an exception
   Contextify.run(code)

}
catch (e) {
   // send message back to parent sandbox.js  with handled  exceptions from the sandbox
    process.send({ status: 'ERROR', errorName: e.name, errorMessage: e.message } ) ; // pass exception object to error handler
}

//releases resource of  the sandbox
Contextify.dispose();


if ( Contextify.RESULT ){
  //the sandbox returns a string. Need to parse again
  // console.log( Contextify.RESULT  );
  // console.log('typeof', Contextify.RESULT);
  var sandboxResult = Contextify.RESULT

  //message the parent sandbox.js with the result
  process.send({ status: 'COMPLETE',result: sandboxResult } ) ; // pass exception object to error handler

  process.exit(0)

}


process.exit(1)
